import fmcloudRestUtil
import time
import datetime
#Test createSchedule and getSchedules

## 3 global variables need to change for each deployment
hostName = 'ServerName.fmi.filemaker-cloud.com'
adminUserName = 'username@companyName.com'
adminPassword = 'yourpassword'
#########
TestPrefix = 'FMScheduleSampleTest'

class fmcloudRestUnitTestSchedule (fmcloudRestUtil.FmRest):

    def deleteAllOldTestSchedules(self):
        scheduleList=self.getSchedules("")
        scheduleArray = scheduleList['schedules']
        for schedule in scheduleArray:
            scheduleId  = schedule['id'] 
            if (schedule['name'].startswith(TestPrefix)):
                deleteResult = self.deleteSchedule(scheduleId)
                 
    def testGetSchedules(self):
        scheduleList=self.getSchedules("")
        print scheduleList    

    def testCreateScheduleMessage(self):        
        postfix =  time.time()
        createSchedulePayload = {
            'name': TestPrefix + str(postfix),
            'taskType': 3,
            'startDate': '2017-8-31-11-30-00',
            'endDate': '2018-8-31-11-30-00',
            'freqType': 3,
            'enabled': 'true',
            'messageText' : "Enter Message Text here",
            'target': 2,
            'daysOfTheWeek': '0111110'
        }
        createScheduleResult = self.createSchedule(createSchedulePayload)
        print createScheduleResult

    def testCreateScriptSchedule(self):
        postfix =  time.time()
        createSchedulePayload = {
            'name': TestPrefix + str(postfix),
            'taskType': 5,
            'startDate': '2017-7-13-11-00-00',
            'freqType': 1,
            'fromTarget':'TargetFileMakerSolutionName',
            'fmScriptName': 'ScriptName',
            'fmScriptAccount' : 'ScriptAccountName',
            'fmScriptPassword' : 'ScriptAccountPassword'
        }
        createScheduleResult = self.createSchedule(createSchedulePayload)
        print createScheduleResult
 
    def testEditScriptSchedule(self):        
        postfix =  time.time()
        editSchedulePayload = {
            'name': TestPrefix + str(postfix),
            'taskType': 5,
            'startDate': '2017-7-13-11-00-00',
            'freqType': 1,
            'fromTarget':'TargetFileMakerSolutionName',
            'fmScriptName': 'ScriptName',
            'fmScriptAccount' : 'ScriptAccountName',
            'fmScriptPassword' : 'ScriptAccountPassword'
        }
        editScheduleResult = self.editSchedule(editSchedulePayload,'1')
        print editScheduleResult
        
    def testEditScheduleMessage(self):        
        postfix =  time.time()
        editSchedulePayload = {
            'name': TestPrefix + str(postfix),
            'taskType': 3,
            'startDate': '2017-7-13-11-00-00',
            'freqType': 1,
            'fromTarget':'TargetFileMakerSolutionName',
            'messageText' : "Enter Message Text here",
            'target': 2
        }
        editScheduleResult = self.editSchedule(editSchedulePayload,'1')
        print editScheduleResult
 
if __name__ == "__main__":
    fmRestUnit = fmcloudRestUnitTestSchedule(hostName, adminUserName, adminPassword)
    fmRestUnit.login()    
    #fmRestUnit.testGetSchedules()
    print "Create message schedule"
    fmRestUnit.testCreateScheduleMessage()
    print "\nGet schedule List"
    fmRestUnit.testGetSchedules()
    #If want to keep the created schedules, comment out the following 3 lines
    print "\nDelete all test schedules after 10 seconds..."
    time.sleep(10)
    fmRestUnit.deleteAllOldTestSchedules()
    print "Logout"
    fmRestUnit.logout()

