import fmcloudRestUtil
import requests
import time

## 5 global variables need to change for each deployment
hostName = 'ServerName.fmi.filemaker-cloud.com'
adminUserName = 'username@companyName.com'
adminPassword = 'yourpassword'
#dashBoard username/password are used in DataAPI for uploading Data
dashboardUserName = 'Admin'
dashboardPassword = 'xxxxxx'
## End of global variable setup
################
def dataAPIAuthenticate(host, username, password, client, solution, layout):
    host = "https://" + host + "/"
    loginHeaders = {"Content-Type": "application/json; charset=UTF-8"}
    authenticatePayload =  {"user" : username,"password" : password, "layout":layout} 
    response = client.post(host + 'fmi/rest/api/auth/' + solution, json = authenticatePayload, headers = loginHeaders )
    token = response.json()['token']
    return token
    
def dataAPILogout(host, token, client, solution, layout):
    host = "https://" + host + "/"
    logoutHeaders = {"Content-Type": "application/json; charset=UTF-8", 'FM-Data-token': token}
    #authenticatePayload =  {"user" : username,"password" : password, "layout":layout} 
    response = client.delete(host + 'fmi/rest/api/auth/' + solution, headers = logoutHeaders )
    print("Logout")   
    
def createRecord(host, token, client, solution, layout, data):
    host = "https://" + host + "/"
    headers = {'Content-Type': 'application/json; charset=UTF-8', 'FM-Data-token': token}
    response = client.post(host + 'fmi/rest/api/record/' + solution + '/' + layout, json = data, headers = headers)
    print("creating a new record in " + solution + ' database with data ' + str(data))
    return response

#Scenario: Query DBS (getFileList) on serverInstance, and update to master. ServerInstance and Master can be same or different instances
fmRestObj = fmcloudRestUtil.FmRest(hostName, 
adminUserName, adminPassword)
loginResult = fmRestObj.login()
print loginResult
tempkey = fmRestObj.getSessionKey()
key = tempkey[0:5] + tempkey[-5:]

queryResult = fmRestObj.getFileList()
print queryResult
if(queryResult['result']!=0):
	print ("Admin API get FileList failed: error code:" + str(queryResult['result']))
	exit()
else:
	print ("Admin API get FileList succeed: code:" + str(queryResult['result']))
#create record based on the queryResult 
client2 = requests.session()

dataAPItoken = dataAPIAuthenticate(hostName , dashboardUserName, dashboardPassword, client2, "Dashboard", 'ServerStatus')

serverResult =createRecord(hostName, dataAPItoken, client2, "Dashboard", "ServerStatus", 
data = {"data": {"key" : key,  "serverName": hostName, "totalDBCount": str(queryResult['totalDBCount']), "goCount": str(queryResult['fmgoCount']), "proCount": str(queryResult['fmproCount']), "webdCount": str(queryResult['fmwebdCount']), "dapiCount": str(queryResult['fmdapiCount'])}})

print "serverResult:" + str(serverResult)
for item in queryResult['files']['files']:
    fileResult = createRecord(hostName, dataAPItoken, client2, "Dashboard", "FileStatus", data = {"data": {"key" : key, "status" : item['status'], "filename": item['filename'], "size":str(item['size'])}})
    #print "fileResult:" + str(fileResult)
for client in queryResult['clients']['clients']:
    clientResult = createRecord(hostName, dataAPItoken, client2, "Dashboard", "ClientStatus", data = {"data": {"key" : key, "status" : client['status'], "computerName":client['computerName'], "userName":client['userName'], "appType":client['appType'], "appVersion":client['appVersion'],"connectTime":client['connectTime'], "connectDuration":client['connectDuration']}})
    #print "clientResult:" + str(clientResult)

dataAPILogout(hostName, dataAPItoken, client2, "Dashboard", "ServerStatus")

fmRestObj.logout()


